# Changelog

## Version 1.0.0

<u>Breaking Changes:</u> ✓ None

<u>Changes:</u>

- Cleanup of codebase for the big step of going to version 1.0
- Project marked as "stable"
- Some minor documentation changes
- Dependencies updated
- Fine-tuning of the tox/test configuration for running on CI

[Downloads](https://git.codebau.dev/pytest-plugins/pytest-csv-params/releases/tag/v1.0.0) |
[Technical Changelog](https://git.codebau.dev/pytest-plugins/pytest-csv-params/compare/v0.4.0...v1.0.0)

## Version 0.4.0

<u>Breaking Changes:</u> ✓ None

<u>Changes:</u>

- Structured Documentation (see source folder `docs/`), it is an important milestone to version 1.0; published under:
  [docs.codebau.dev/pytest-plugins/pytest-csv-params](https://docs.codebau.dev/pytest-plugins/pytest-csv-params)
- Documentation widely extended with a lot of extra information
- A more detailed changelog as part of this documentation
- Some source code / API documentation
- `README.md` reduced in favor of the structured documentation 

[Downloads](https://git.codebau.dev/pytest-plugins/pytest-csv-params/releases/tag/v0.4.0) |
[Technical Changelog](https://git.codebau.dev/pytest-plugins/pytest-csv-params/compare/v0.3.0...v0.4.0)

## Version 0.3.0

<u>Breaking Changes:</u>

- Column names are now tested for reserved names. If you used reserved names in the past, this might break your tests,
  despite the fact, that you are greater trouble already.

<u>Changes:</u>

- Much better handling of column names (headers) in CSV files:
  - Invalid characters are replaced by a `_`
  - Names are checked if they are reserved keywords or builtin names
- A new parameter `header_renames` to the decorator `@csv_params` allows you to bring your CSV column names to clean
  variable names
- See `README.md` for further details

[Downloads](https://git.codebau.dev/pytest-plugins/pytest-csv-params/releases/tag/v0.3.0) |
[Technical Changelog](https://git.codebau.dev/pytest-plugins/pytest-csv-params/compare/v0.2.2...v0.3.0)

## Version 0.2.2

<u>Breaking Changes:</u> ✓ None

<u>Changes:</u>

- Library updates
- For Developers: Added a few extra tests for base functionality of pytest that is used in this plugin.

[Downloads](https://git.codebau.dev/pytest-plugins/pytest-csv-params/releases/tag/v0.2.2) |
[Technical Changelog](https://git.codebau.dev/pytest-plugins/pytest-csv-params/compare/v0.2.0...v0.2.2)

## Version 0.2.0

<u>Breaking Changes:</u>

- The order of the parameters for the decorator `@csv_params` changed to realize the new shorthand form of the decorator
  (see below). If you used the decorator with keyword parameters only (like it is written in the documentation), you are
  fine.

<u>Changes</u>

- New shorthand form for the decorator `@csv_params`. This is very handy when you have CSV files with no ID column and
  column names that match the test functions parameters names. Together with the command line parameter introduced in
  version 0.1.0 you can create very short decorators. See `README.md` for details.
- For Developers: Mypy has been added to the test chain for typing analysis

[Downloads](https://git.codebau.dev/pytest-plugins/pytest-csv-params/releases/tag/v0.2.0) |
[Technical Changelog](https://git.codebau.dev/pytest-plugins/pytest-csv-params/compare/v0.1.0...v0.2.0)

## Version 0.1.0

<u>Breaking Changes:</u> ✓ None

<u>Changes:</u>

- A new command line argument `--csv-params-base-dir` allows you to set a base dir for all relative CSV files. This is
  great when you have a central storage for your test data. See `README.md` for more details.
- Some documentation fixes
- Some changes to the tox configuration in order to report coverage correctly

[Downloads](https://git.codebau.dev/pytest-plugins/pytest-csv-params/releases/tag/v0.1.0) |
[Technical Changelog](https://git.codebau.dev/pytest-plugins/pytest-csv-params/compare/v0.0.4...v0.1.0)

## Version 0.0.4

<u>Breaking Changes:</u> ✓ None

<u>Changes:</u>

- Minor documentation bugfixes

[Downloads](https://git.codebau.dev/pytest-plugins/pytest-csv-params/releases/tag/v0.0.4) |
[Technical Changelog](https://git.codebau.dev/pytest-plugins/pytest-csv-params/compare/v0.0.3...v0.0.4)

## Version 0.0.3

<u>Breaking Changes:</u> ✓ None 

<u>Changes:</u>

- Initial Public Release
- Delivered the `@csv_params` decorator

[Downloads](https://git.codebau.dev/pytest-plugins/pytest-csv-params/releases/tag/v0.0.3) |
[Technical Changelog](https://git.codebau.dev/pytest-plugins/pytest-csv-params/compare/v0.0.2...v0.0.3)
